
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Inventory_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.create(
            {
                id: data.id || undefined,
        
        item_category: data.item_category
        ||
        null
            ,
            
        item_name: data.item_name
        ||
        null
            ,
            
        sku: data.sku
        ||
        null
            ,
            
        unit: data.unit
        ||
        null
            ,
            
        quantity_on_hand: data.quantity_on_hand
        ||
        null
            ,
            
        reorder_level: data.reorder_level
        ||
        null
            ,
            
        unit_cost: data.unit_cost
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await inventory_items.setTenant( data.tenant || null, {
            transaction,
        });
        
        await inventory_items.setLocation( data.location || null, {
            transaction,
        });
        
        await inventory_items.setFeed_product( data.feed_product || null, {
            transaction,
        });
        
        await inventory_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return inventory_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const inventory_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                item_category: item.item_category
            ||
            null
            ,
            
                item_name: item.item_name
            ||
            null
            ,
            
                sku: item.sku
            ||
            null
            ,
            
                unit: item.unit
            ||
            null
            ,
            
                quantity_on_hand: item.quantity_on_hand
            ||
            null
            ,
            
                reorder_level: item.reorder_level
            ||
            null
            ,
            
                unit_cost: item.unit_cost
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const inventory_items = await db.inventory_items.bulkCreate(inventory_itemsData, { transaction });

        // For each item created, replace relation files
        

        return inventory_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const inventory_items = await db.inventory_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.item_category !== undefined) updatePayload.item_category = data.item_category;
        
        
        if (data.item_name !== undefined) updatePayload.item_name = data.item_name;
        
        
        if (data.sku !== undefined) updatePayload.sku = data.sku;
        
        
        if (data.unit !== undefined) updatePayload.unit = data.unit;
        
        
        if (data.quantity_on_hand !== undefined) updatePayload.quantity_on_hand = data.quantity_on_hand;
        
        
        if (data.reorder_level !== undefined) updatePayload.reorder_level = data.reorder_level;
        
        
        if (data.unit_cost !== undefined) updatePayload.unit_cost = data.unit_cost;
        
        
        updatePayload.updatedById = currentUser.id;

        await inventory_items.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await inventory_items.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.location !== undefined) {
            await inventory_items.setLocation(
              
              data.location,
              
              { transaction }
            );
        }
        
        if (data.feed_product !== undefined) {
            await inventory_items.setFeed_product(
              
              data.feed_product,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await inventory_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return inventory_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of inventory_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of inventory_items) {
                await record.destroy({transaction});
            }
        });


        return inventory_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findByPk(id, options);

        await inventory_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await inventory_items.destroy({
            transaction
        });

        return inventory_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findOne(
            { where },
            { transaction },
        );

        if (!inventory_items) {
            return inventory_items;
        }

        const output = inventory_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        output.inventory_movements_inventory_item = await inventory_items.getInventory_movements_inventory_item({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await inventory_items.getTenant({
            transaction
        });
        
        
        output.location = await inventory_items.getLocation({
            transaction
        });
        
        
        output.feed_product = await inventory_items.getFeed_product({
            transaction
        });
        
        
        output.organizations = await inventory_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              tenant_name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tenant_locations,
        as: 'location',
        
        where: filter.location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.location.split('|').map(term => Utils.uuid(term)) } },
            {
              location_name: {
                [Op.or]: filter.location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.feed_products,
        as: 'feed_product',
        
        where: filter.feed_product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.feed_product.split('|').map(term => Utils.uuid(term)) } },
            {
              product_name: {
                [Op.or]: filter.feed_product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.item_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inventory_items',
                        'item_name',
                        filter.item_name,
                    ),
                };
            }
            
            if (filter.sku) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inventory_items',
                        'sku',
                        filter.sku,
                    ),
                };
            }
            
            if (filter.unit) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inventory_items',
                        'unit',
                        filter.unit,
                    ),
                };
            }
            

            
            

            
            if (filter.quantity_on_handRange) {
                const [start, end] = filter.quantity_on_handRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_on_hand: {
                    ...where.quantity_on_hand,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_on_hand: {
                    ...where.quantity_on_hand,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reorder_levelRange) {
                const [start, end] = filter.reorder_levelRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reorder_level: {
                    ...where.reorder_level,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reorder_level: {
                    ...where.reorder_level,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_costRange) {
                const [start, end] = filter.unit_costRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_cost: {
                    ...where.unit_cost,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_cost: {
                    ...where.unit_cost,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.item_category) {
                where = {
                    ...where,
                item_category: filter.item_category,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.inventory_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'inventory_items',
                        'item_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.inventory_items.findAll({
            attributes: [ 'id', 'item_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['item_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.item_name,
        }));
    }

    
};

